diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post.php	2013-07-20 15:20:47.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 2310,2315 ****
--- 2353,2386 ----
  }
  
  /**
+  * Resets the page_on_front, show_on_front, and page_for_post settings when a
+  * linked page is deleted or trashed.
+  *
+  * Also ensures the post is no longer sticky.
+  *
+  * @access private
+  * @since 3.7.0
+  * @param $post_id
+  */
+ function _reset_front_page_settings_for_post( $post_id ) {
+ 	$post = get_post( $post_id );
+ 	if ( 'page' == $post->post_type ) {
+ 	 	// If the page is defined in option page_on_front or post_for_posts,
+ 		// adjust the corresponding options
+ 		if ( get_option( 'page_on_front' ) == $post->ID ) {
+ 			update_option( 'show_on_front', 'posts' );
+ 			update_option( 'page_on_front', 0 );
+ 		}
+ 		if ( get_option( 'page_for_posts' ) == $post->ID ) {
+ 			delete_option( 'page_for_posts', 0 );
+ 		}
+ 	}
+ 	unstick_post( $post->ID );
+ }
+ add_action( 'before_delete_post', '_reset_front_page_settings_for_post' );
+ add_action( 'wp_trash_post',      '_reset_front_page_settings_for_post' );
+ 
+ /**
   * Moves a post or page to the Trash
   *
   * If trash is disabled, the post or page is permanently deleted.
***************
*** 2589,2595 ****
  }
  
  /**
!  * Insert a post.
   *
   * If the $postarr parameter has 'ID' set to a value, then post will be updated.
   *
--- 2660,2666 ----
  }
  
  /**
!  * Insert or update a post.
   *
   * If the $postarr parameter has 'ID' set to a value, then post will be updated.
   *
***************
*** 2597,2634 ****
   * and 'post_date_gmt' keys. You can close the comments or open the comments by
   * setting the value for 'comment_status' key.
   *
!  * The defaults for the parameter $postarr are:
!  *     'post_status'   - Default is 'draft'.
!  *     'post_type'     - Default is 'post'.
!  *     'post_author'   - Default is current user ID ($user_ID). The ID of the user who added the post.
!  *     'ping_status'   - Default is the value in 'default_ping_status' option.
!  *                       Whether the attachment can accept pings.
!  *     'post_parent'   - Default is 0. Set this for the post it belongs to, if any.
!  *     'menu_order'    - Default is 0. The order it is displayed.
!  *     'to_ping'       - Whether to ping.
!  *     'pinged'        - Default is empty string.
!  *     'post_password' - Default is empty string. The password to access the attachment.
!  *     'guid'          - Global Unique ID for referencing the attachment.
!  *     'post_content_filtered' - Post content filtered.
!  *     'post_excerpt'  - Post excerpt.
   *
   * @since 1.0.0
-  * @uses $wpdb
-  * @uses $user_ID
-  * @uses do_action() Calls 'pre_post_update' on post ID if this is an update.
-  * @uses do_action() Calls 'edit_post' action on post ID and post data if this is an update.
-  * @uses do_action() Calls 'save_post' and 'wp_insert_post' on post id and post data just before returning.
-  * @uses apply_filters() Calls 'wp_insert_post_data' passing $data, $postarr prior to database update or insert.
-  * @uses wp_transition_post_status()
   *
!  * @param array $postarr Elements that make up post to insert.
!  * @param bool $wp_error Optional. Allow return of WP_Error on failure.
!  * @return int|WP_Error The value 0 or WP_Error on failure. The post ID on success.
   */
! function wp_insert_post($postarr, $wp_error = false) {
! 	global $wpdb, $user_ID;
  
! 	$defaults = array('post_status' => 'draft', 'post_type' => 'post', 'post_author' => $user_ID,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0,
  		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0,
--- 2668,2705 ----
   * and 'post_date_gmt' keys. You can close the comments or open the comments by
   * setting the value for 'comment_status' key.
   *
!  * @global wpdb $wpdb    WordPress database abstraction object.
   *
   * @since 1.0.0
   *
!  * @param array $postarr {
!  *     An array of elements that make up a post to update or insert.
!  *
!  *     @type int    'ID'                    The post ID. If equal to something other than 0, the post with that ID will
!  *                                          be updated. Default 0.
!  *     @type string 'post_status'           The post status. Default 'draft'.
!  *     @type string 'post_type'             The post type. Default 'post'.
!  *     @type int    'post_author'           The ID of the user who added the post. Default the current user ID.
!  *     @type bool   'ping_status'           Whether the post can accept pings. Default value of 'default_ping_status' option.
!  *     @type int    'post_parent'           Set this for the post it belongs to, if any. Default 0.
!  *     @type int    'menu_order'            The order it is displayed. Default 0.
!  *     @type string 'to_ping'               Space or carriage return-separated list of URLs to ping. Default empty string.
!  *     @type string 'pinged'                Space or carriage return-separated list of URLs that have been pinged.
!  *                                          Default empty string.
!  *     @type string 'post_password          The password to access the post. Default empty string.
!  *     @type string 'guid'                  Global Unique ID for referencing the post.
!  *     @type string 'post_content_filtered' The filtered post content. Default empty string.
!  *     @type string 'post_excerpt'          The post excerpt. Default empty string.
!  * }
!  * @param bool  $wp_error Optional. Allow return of WP_Error on failure.
!  * @return int|WP_Error The post ID on success. The value 0 or WP_Error on failure.
   */
! function wp_insert_post( $postarr, $wp_error = false ) {
! 	global $wpdb;
! 
! 	$user_id = get_current_user_id();
  
! 	$defaults = array('post_status' => 'draft', 'post_type' => 'post', 'post_author' => $user_id,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0,
  		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0,
***************
*** 2693,2699 ****
  	}
  
  	if ( empty($post_author) )
! 		$post_author = $user_ID;
  
  	// Don't allow contributors to set the post slug for pending review posts
  	if ( 'pending' == $post_status && !current_user_can( 'publish_posts' ) )
--- 2764,2770 ----
  	}
  
  	if ( empty($post_author) )
! 		$post_author = $user_id;
  
  	// Don't allow contributors to set the post slug for pending review posts
  	if ( 'pending' == $post_status && !current_user_can( 'publish_posts' ) )
***************
*** 2879,2886 ****
  		do_action( 'post_updated', $post_ID, $post_after, $post_before);
  	}
  
! 	do_action('save_post', $post_ID, $post);
! 	do_action('wp_insert_post', $post_ID, $post);
  
  	return $post_ID;
  }
--- 2950,2958 ----
  		do_action( 'post_updated', $post_ID, $post_after, $post_before);
  	}
  
! 	do_action( "save_post_{$post->post_type}", $post_ID, $post, $update );
! 	do_action( 'save_post', $post_ID, $post, $update );
! 	do_action( 'wp_insert_post', $post_ID, $post, $update );
  
  	return $post_ID;
  }
***************
*** 2949,2955 ****
   *
   * @since 2.1.0
   * @uses $wpdb
!  * @uses do_action() Calls 'edit_post', 'save_post', and 'wp_insert_post' on post_id and post data.
   *
   * @param int|object $post Post ID or object.
   */
--- 3021,3027 ----
   *
   * @since 2.1.0
   * @uses $wpdb
!  * @uses do_action() Calls 'edit_post', 'save_post_{$post_type}', 'save_post' and 'wp_insert_post' on post_id and post data.
   *
   * @param int|object $post Post ID or object.
   */
***************
*** 2971,2978 ****
  	wp_transition_post_status( 'publish', $old_status, $post );
  
  	do_action( 'edit_post', $post->ID, $post );
! 	do_action( 'save_post', $post->ID, $post );
! 	do_action( 'wp_insert_post', $post->ID, $post );
  }
  
  /**
--- 3043,3051 ----
  	wp_transition_post_status( 'publish', $old_status, $post );
  
  	do_action( 'edit_post', $post->ID, $post );
! 	do_action( "save_post_{$post->post_type}", $post->ID, $post, true );
! 	do_action( 'save_post', $post->ID, $post, true );
! 	do_action( 'wp_insert_post', $post->ID, $post, true );
  }
  
  /**
***************
*** 3185,3208 ****
   * @since 2.1.0
   *
   * @param int $post_ID Post ID.
!  * @param array $post_categories Optional. List of categories.
   * @return bool|mixed
   */
! function wp_set_post_categories($post_ID = 0, $post_categories = array()) {
  	$post_ID = (int) $post_ID;
  	$post_type = get_post_type( $post_ID );
  	$post_status = get_post_status( $post_ID );
  	// If $post_categories isn't already an array, make it one:
! 	if ( !is_array($post_categories) || empty($post_categories) ) {
! 		if ( 'post' == $post_type && 'auto-draft' != $post_status )
  			$post_categories = array( get_option('default_category') );
! 		else
  			$post_categories = array();
  	} else if ( 1 == count($post_categories) && '' == reset($post_categories) ) {
  		return true;
  	}
  
! 	return wp_set_post_terms($post_ID, $post_categories, 'category');
  }
  
  /**
--- 3258,3285 ----
   * @since 2.1.0
   *
   * @param int $post_ID Post ID.
!  * @param array|int $post_categories Optional. List of categories or ID of category.
!  * @param bool $append If true, don't delete existing categories, just add on. If false, replace the categories with the new categories.
   * @return bool|mixed
   */
! function wp_set_post_categories( $post_ID = 0, $post_categories = array(), $append = false ) {
  	$post_ID = (int) $post_ID;
  	$post_type = get_post_type( $post_ID );
  	$post_status = get_post_status( $post_ID );
  	// If $post_categories isn't already an array, make it one:
! 	$post_categories = (array) $post_categories;
! 	if ( empty( $post_categories ) ) {
! 		if ( 'post' == $post_type && 'auto-draft' != $post_status ) {
  			$post_categories = array( get_option('default_category') );
! 			$append = false;
! 		} else {
  			$post_categories = array();
+ 		}
  	} else if ( 1 == count($post_categories) && '' == reset($post_categories) ) {
  		return true;
  	}
  
! 	return wp_set_post_terms( $post_ID, $post_categories, 'category', $append );
  }
  
  /**
***************
*** 3268,3274 ****
   * Retrieve enclosures already enclosed for a post.
   *
   * @since 1.5.0
-  * @uses $wpdb
   *
   * @param int $post_id Post ID.
   * @return array List of enclosures
--- 3345,3350 ----
***************
*** 3551,3565 ****
   * @since 1.5.0
   *
   * @param mixed $page Page object or page ID.
!  * @return string Page URI.
   */
! function get_page_uri($page) {
  	$page = get_post( $page );
  
  	$uri = $page->post_name;
  
  	foreach ( $page->ancestors as $parent ) {
! 		$uri = get_post( $parent )->post_name . "/" . $uri;
  	}
  
  	return $uri;
--- 3627,3644 ----
   * @since 1.5.0
   *
   * @param mixed $page Page object or page ID.
!  * @return string|false Page URI, false on error.
   */
! function get_page_uri( $page ) {
  	$page = get_post( $page );
  
+ 	if ( ! $page )
+ 		return false;
+ 
  	$uri = $page->post_name;
  
  	foreach ( $page->ancestors as $parent ) {
! 		$uri = get_post( $parent )->post_name . '/' . $uri;
  	}
  
  	return $uri;
***************
*** 3568,3584 ****
  /**
   * Retrieve a list of pages.
   *
!  * The defaults that can be overridden are the following: 'child_of',
!  * 'sort_order', 'sort_column', 'post_title', 'hierarchical', 'exclude',
!  * 'include', 'meta_key', 'meta_value','authors', 'number', and 'offset'.
   *
   * @since 1.5.0
-  * @uses $wpdb
   *
!  * @param mixed $args Optional. Array or string of options that overrides defaults.
!  * @return array List of pages matching defaults or $args
   */
! function get_pages($args = '') {
  	global $wpdb;
  
  	$pages = false;
--- 3647,3687 ----
  /**
   * Retrieve a list of pages.
   *
!  * @global wpdb $wpdb WordPress database abstraction object
   *
   * @since 1.5.0
   *
!  * @param mixed $args {
!  *     Array or string of arguments. Optional.
!  *
!  *     @type int    'child_of'     Page ID to return child and grandchild pages of. Default 0, or no restriction.
!  *     @type string 'sort_order'   How to sort retrieved pages.
!  *                                 Default 'ASC'. Accepts 'ASC', 'DESC'.
!  *     @type string 'sort_column'  What columns to sort pages by, comma-separated.
!  *                                 Default 'post_title'. Accepts 'post_author', 'post_date', 'post_title', 'post_name',
!  *                                 'post_modified', 'post_modified_gmt', 'menu_order', 'post_parent', 'ID', 'rand',
!  *                                 'comment_count'. 'post_' can be omitted for any values that start with it.
!  *     @type bool   'hierarchical' Whether to return pages hierarchically. Default true.
!  *     @type array  'exclude'      Array of page IDs to exclude.
!  *     @type array  'include'      Array of page IDs to include. Cannot be used with 'child_of', 'parent', 'exclude',
!  *                                 'meta_key', 'meta_value', or 'hierarchical'.
!  *     @type string 'meta_key'     Only include pages with this meta key.
!  *     @type string 'meta_value'   Only include pages with this meta value.
!  *     @type string 'authors'      A comma-separated list of author IDs.
!  *     @type int    'parent'       Page ID to return direct children of. 'hierarchical' must be false.
!  *                                 Default -1, or no restriction.
!  *     @type int    'exclude_tree' Remove all children of the given ID from returned pages.
!  *     @type int    'number'       The number of pages to return. Default 0, or all pages.
!  *     @type int    'offset'       The number of pages to skip before returning. Requires 'number'.
!  *                                 Default 0.
!  *     @type string 'post_type'    The post type to query.
!  *                                 Default 'page'.
!  *     @type string 'post_status'  A comma-separated list of post status types to include.
!  *                                 Default 'publish'.
!  * }
!  * @return array List of pages matching defaults or $args.
   */
! function get_pages( $args = array() ) {
  	global $wpdb;
  
  	$pages = false;
***************
*** 3603,3608 ****
--- 3706,3714 ----
  	if ( !in_array( $post_type, $hierarchical_post_types ) )
  		return $pages;
  
+ 	if ( $parent && ! $child_of )
+ 		$hierarchical = false;
+ 
  	// Make sure we have a valid post status
  	if ( !is_array( $post_status ) )
  		$post_status = explode( ',', $post_status );
***************
*** 3629,3635 ****
  		$cache = array();
  
  	$inclusions = '';
! 	if ( !empty($include) ) {
  		$child_of = 0; //ignore child_of, parent, exclude, meta_key, and meta_value params if using include
  		$parent = -1;
  		$exclude = '';
--- 3735,3741 ----
  		$cache = array();
  
  	$inclusions = '';
! 	if ( ! empty( $include ) ) {
  		$child_of = 0; //ignore child_of, parent, exclude, meta_key, and meta_value params if using include
  		$parent = -1;
  		$exclude = '';
***************
*** 3637,3668 ****
  		$meta_value = '';
  		$hierarchical = false;
  		$incpages = wp_parse_id_list( $include );
! 		if ( ! empty( $incpages ) ) {
! 			foreach ( $incpages as $incpage ) {
! 				if (empty($inclusions))
! 					$inclusions = $wpdb->prepare(' AND ( ID = %d ', $incpage);
! 				else
! 					$inclusions .= $wpdb->prepare(' OR ID = %d ', $incpage);
! 			}
! 		}
  	}
- 	if (!empty($inclusions))
- 		$inclusions .= ')';
  
  	$exclusions = '';
! 	if ( !empty($exclude) ) {
  		$expages = wp_parse_id_list( $exclude );
! 		if ( ! empty( $expages ) ) {
! 			foreach ( $expages as $expage ) {
! 				if (empty($exclusions))
! 					$exclusions = $wpdb->prepare(' AND ( ID <> %d ', $expage);
! 				else
! 					$exclusions .= $wpdb->prepare(' AND ID <> %d ', $expage);
! 			}
! 		}
  	}
- 	if (!empty($exclusions))
- 		$exclusions .= ')';
  
  	$author_query = '';
  	if (!empty($authors)) {
--- 3743,3758 ----
  		$meta_value = '';
  		$hierarchical = false;
  		$incpages = wp_parse_id_list( $include );
! 		if ( ! empty( $incpages ) )
! 			$inclusions = ' AND ID IN (' . implode( ',', $incpages ) .  ')';
  	}
  
  	$exclusions = '';
! 	if ( ! empty( $exclude ) ) {
  		$expages = wp_parse_id_list( $exclude );
! 		if ( ! empty( $expages ) )
! 			$exclusions = ' AND ID NOT IN (' . implode( ',', $expages ) .  ')';
  	}
  
  	$author_query = '';
  	if (!empty($authors)) {
***************
*** 3705,3712 ****
  
  	}
  
! 	if ( $parent >= 0 )
  		$where .= $wpdb->prepare(' AND post_parent = %d ', $parent);
  
  	if ( 1 == count( $post_status ) ) {
  		$where_post_type = $wpdb->prepare( "post_type = %s AND post_status = %s", $post_type, array_shift( $post_status ) );
--- 3795,3807 ----
  
  	}
  
! 	if ( is_array( $parent ) ) {
! 		$post_parent__in = implode( ',', array_map( 'absint', (array) $parent ) );
! 		if ( ! empty( $post_parent__in ) )
! 			$where .= " AND post_parent IN ($post_parent__in)";
! 	} elseif ( $parent >= 0 ) {
  		$where .= $wpdb->prepare(' AND post_parent = %d ', $parent);
+ 	}
  
  	if ( 1 == count( $post_status ) ) {
  		$where_post_type = $wpdb->prepare( "post_type = %s AND post_status = %s", $post_type, array_shift( $post_status ) );
***************
*** 3863,3869 ****
   *
   * @since 2.0.0
   * @uses $wpdb
-  * @uses $user_ID
   * @uses do_action() Calls 'edit_attachment' on $post_ID if this is an update.
   * @uses do_action() Calls 'add_attachment' on $post_ID if this is not an update.
   *
--- 3958,3963 ----
***************
*** 3873,3883 ****
   * @return int Attachment ID.
   */
  function wp_insert_attachment($object, $file = false, $parent = 0) {
! 	global $wpdb, $user_ID;
  
! 	$defaults = array('post_status' => 'inherit', 'post_type' => 'post', 'post_author' => $user_ID,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0, 'post_title' => '',
! 		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0, 'context' => '');
  
  	$object = wp_parse_args($object, $defaults);
--- 3967,3979 ----
   * @return int Attachment ID.
   */
  function wp_insert_attachment($object, $file = false, $parent = 0) {
! 	global $wpdb;
! 
! 	$user_id = get_current_user_id();
  
! 	$defaults = array('post_status' => 'inherit', 'post_type' => 'post', 'post_author' => $user_id,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0, 'post_title' => '',
! 		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '', 'post_content' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0, 'context' => '');
  
  	$object = wp_parse_args($object, $defaults);
***************
*** 3892,3898 ****
  	extract($object, EXTR_SKIP);
  
  	if ( empty($post_author) )
! 		$post_author = $user_ID;
  
  	$post_type = 'attachment';
  
--- 3988,3994 ----
  	extract($object, EXTR_SKIP);
  
  	if ( empty($post_author) )
! 		$post_author = $user_id;
  
  	$post_type = 'attachment';
  
***************
*** 4094,4099 ****
--- 4190,4196 ----
  		// Don't delete the thumb if another attachment uses it
  		if (! $wpdb->get_row( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE meta_key = '_wp_attachment_metadata' AND meta_value LIKE %s AND post_id <> %d", '%' . $meta['thumb'] . '%', $post_id)) ) {
  			$thumbfile = str_replace(basename($file), $meta['thumb'], $file);
+ 			/** This filter is documented in wp-admin/custom-header.php */
  			$thumbfile = apply_filters('wp_delete_file', $thumbfile);
  			@ unlink( path_join($uploadpath['basedir'], $thumbfile) );
  		}
***************
*** 4101,4106 ****
--- 4198,4204 ----
  
  	// remove intermediate and backup images if there are any
  	foreach ( $intermediate_sizes as $intermediate ) {
+ 		/** This filter is documented in wp-admin/custom-header.php */
  		$intermediate_file = apply_filters( 'wp_delete_file', $intermediate['path'] );
  		@ unlink( path_join($uploadpath['basedir'], $intermediate_file) );
  	}
***************
*** 4108,4118 ****
--- 4206,4218 ----
  	if ( is_array($backup_sizes) ) {
  		foreach ( $backup_sizes as $size ) {
  			$del_file = path_join( dirname($meta['file']), $size['file'] );
+ 			/** This filter is documented in wp-admin/custom-header.php */
  			$del_file = apply_filters('wp_delete_file', $del_file);
  			@ unlink( path_join($uploadpath['basedir'], $del_file) );
  		}
  	}
  
+ 	/** This filter is documented in wp-admin/custom-header.php */
  	$file = apply_filters('wp_delete_file', $file);
  
  	if ( ! empty($file) )
***************
*** 4416,4423 ****
   *
   * @since 2.2.0
   *
-  * @uses $user_ID
-  *
   * @param string $post_type currently only supports 'post' or 'page'.
   * @return string SQL code that can be added to a where clause.
   */
--- 4516,4521 ----
***************
*** 4438,4444 ****
   * @return string SQL WHERE code that can be added to a query.
   */
  function get_posts_by_author_sql( $post_type, $full = true, $post_author = null, $public_only = false ) {
! 	global $user_ID, $wpdb;
  
  	// Private posts
  	$post_type_obj = get_post_type_object( $post_type );
--- 4536,4542 ----
   * @return string SQL WHERE code that can be added to a query.
   */
  function get_posts_by_author_sql( $post_type, $full = true, $post_author = null, $public_only = false ) {
! 	global $wpdb;
  
  	// Private posts
  	$post_type_obj = get_post_type_object( $post_type );
***************
*** 4468,4474 ****
  			$sql .= " OR post_status = 'private'";
  		} elseif ( is_user_logged_in() ) {
  			// Users can view their own private posts.
! 			$id = (int) $user_ID;
  			if ( null === $post_author || ! $full ) {
  				$sql .= " OR post_status = 'private' AND post_author = $id";
  			} elseif ( $id == (int) $post_author ) {
--- 4566,4572 ----
  			$sql .= " OR post_status = 'private'";
  		} elseif ( is_user_logged_in() ) {
  			// Users can view their own private posts.
! 			$id = get_current_user_id();
  			if ( null === $post_author || ! $full ) {
  				$sql .= " OR post_status = 'private' AND post_author = $id";
  			} elseif ( $id == (int) $post_author ) {
***************
*** 4642,4648 ****
   * @subpackage Cache
   * @since 1.5.0
   *
-  * @uses $wpdb
   * @uses update_post_cache()
   * @uses update_object_term_cache()
   * @uses update_postmeta_cache()
--- 4740,4745 ----
***************
*** 4697,4704 ****
   * @subpackage Cache
   * @since 2.1.0
   *
-  * @uses $wpdb
-  *
   * @param array $post_ids List of post IDs.
   * @return bool|array Returns false if there is nothing to update or an array of metadata.
   */
--- 4794,4799 ----
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post-template.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/post-template.php	2013-09-04 12:40:02.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/post-template.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 458,464 ****
  	} elseif ( is_archive() ) {
  		if ( is_post_type_archive() ) {
  			$classes[] = 'post-type-archive';
! 			$classes[] = 'post-type-archive-' . sanitize_html_class( get_query_var( 'post_type' ) );
  		} else if ( is_author() ) {
  			$author = $wp_query->get_queried_object();
  			$classes[] = 'author';
--- 458,467 ----
  	} elseif ( is_archive() ) {
  		if ( is_post_type_archive() ) {
  			$classes[] = 'post-type-archive';
! 			$post_type = get_query_var( 'post_type' );
! 			if ( is_array( $post_type ) )
! 				$post_type = reset( $post_type );
! 			$classes[] = 'post-type-archive-' . sanitize_html_class( $post_type );
  		} else if ( is_author() ) {
  			$author = $wp_query->get_queried_object();
  			$classes[] = 'author';
***************
*** 650,656 ****
  	$r = apply_filters( 'wp_link_pages_args', $r );
  	extract( $r, EXTR_SKIP );
  
! 	global $page, $numpages, $multipage, $more, $pagenow;
  
  	$output = '';
  	if ( $multipage ) {
--- 653,659 ----
  	$r = apply_filters( 'wp_link_pages_args', $r );
  	extract( $r, EXTR_SKIP );
  
! 	global $page, $numpages, $multipage, $more;
  
  	$output = '';
  	if ( $multipage ) {
***************
*** 875,881 ****
   *
   * <ul>
   * <li><strong>sort_column</strong> - How to sort the list of pages. Defaults
!  * to page title. Use column for posts table.</li>
   * <li><strong>menu_class</strong> - Class to use for the div ID which contains
   * the page list. Defaults to 'menu'.</li>
   * <li><strong>echo</strong> - Whether to echo list or return it. Defaults to
--- 878,884 ----
   *
   * <ul>
   * <li><strong>sort_column</strong> - How to sort the list of pages. Defaults
!  * to 'menu_order, post_title'. Use column for posts table.</li>
   * <li><strong>menu_class</strong> - Class to use for the div ID which contains
   * the page list. Defaults to 'menu'.</li>
   * <li><strong>echo</strong> - Whether to echo list or return it. Defaults to
***************
*** 910,916 ****
  		$class = '';
  		if ( is_front_page() && !is_paged() )
  			$class = 'class="current_page_item"';
! 		$menu .= '<li ' . $class . '><a href="' . home_url( '/' ) . '" title="' . esc_attr($text) . '">' . $args['link_before'] . $text . $args['link_after'] . '</a></li>';
  		// If the front page is a page, add it to the exclude list
  		if (get_option('show_on_front') == 'page') {
  			if ( !empty( $list_args['exclude'] ) ) {
--- 913,919 ----
  		$class = '';
  		if ( is_front_page() && !is_paged() )
  			$class = 'class="current_page_item"';
! 		$menu .= '<li ' . $class . '><a href="' . home_url( '/' ) . '">' . $args['link_before'] . $text . $args['link_after'] . '</a></li>';
  		// If the front page is a page, add it to the exclude list
  		if (get_option('show_on_front') == 'page') {
  			if ( !empty( $list_args['exclude'] ) ) {
***************
*** 954,959 ****
--- 957,967 ----
  	else
  		$walker = $r['walker'];
  
+ 	foreach ( (array) $pages as $page ) {
+ 		if ( $page->post_parent )
+ 			$r['pages_with_children'][ $page->post_parent ] = true;
+ 	}
+ 
  	$args = array($pages, $depth, $r, $current_page);
  	return call_user_func_array(array($walker, 'walk'), $args);
  }
***************
*** 1042,1047 ****
--- 1050,1059 ----
  
  		extract($args, EXTR_SKIP);
  		$css_class = array('page_item', 'page-item-'.$page->ID);
+ 
+ 		if( isset( $args['pages_with_children'][ $page->ID ] ) )
+ 			$css_class[] = 'page_item_has_children';
+ 
  		if ( !empty($current_page) ) {
  			$_current_page = get_post( $current_page );
  			if ( in_array( $page->ID, $_current_page->ancestors ) )
***************
*** 1059,1064 ****
--- 1071,1077 ----
  		if ( '' === $page->post_title )
  			$page->post_title = sprintf( __( '#%d (no title)' ), $page->ID );
  
+ 		/** This filter is documented in wp-includes/post-template.php */
  		$output .= $indent . '<li class="' . $css_class . '"><a href="' . get_permalink($page->ID) . '">' . $link_before . apply_filters( 'the_title', $page->post_title, $page->ID ) . $link_after . '</a>';
  
  		if ( !empty($show_date) ) {
***************
*** 1191,1197 ****
  	if ( trim( $link_text ) == '' )
  		$link_text = $_post->post_title;
  
! 	return apply_filters( 'wp_get_attachment_link', "<a href='$url' title='$post_title'>$link_text</a>", $id, $size, $permalink, $icon, $text );
  }
  
  /**
--- 1204,1210 ----
  	if ( trim( $link_text ) == '' )
  		$link_text = $_post->post_title;
  
! 	return apply_filters( 'wp_get_attachment_link', "<a href='$url'>$link_text</a>", $id, $size, $permalink, $icon, $text );
  }
  
  /**
***************
*** 1233,1244 ****
  function get_the_password_form( $post = 0 ) {
  	$post = get_post( $post );
  	$label = 'pwbox-' . ( empty($post->ID) ? rand() : $post->ID );
! 	$output = '<form action="' . esc_url( site_url( 'wp-login.php?action=postpass', 'login_post' ) ) . '" method="post">
! 	<p>' . __("This post is password protected. To view it please enter your password below:") . '</p>
! 	<p><label for="' . $label . '">' . __("Password:") . ' <input name="post_password" id="' . $label . '" type="password" size="20" /></label> <input type="submit" name="Submit" value="' . esc_attr__("Submit") . '" /></p>
! </form>
  	';
! 	return apply_filters('the_password_form', $output);
  }
  
  /**
--- 1246,1257 ----
  function get_the_password_form( $post = 0 ) {
  	$post = get_post( $post );
  	$label = 'pwbox-' . ( empty($post->ID) ? rand() : $post->ID );
! 	$output = '<form action="' . esc_url( site_url( 'wp-login.php?action=postpass', 'login_post' ) ) . '" class="post-password-form" method="post">
! 	<p>' . __( 'This content is password protected. To view it please enter your password below:' ) . '</p>
! 	<p><label for="' . $label . '">' . __( 'Password:' ) . ' <input name="post_password" id="' . $label . '" type="password" size="20" /></label> <input type="submit" name="Submit" value="' . esc_attr__( 'Submit' ) . '" /></p>
! 	</form>
  	';
! 	return apply_filters( 'the_password_form', $output );
  }
  
  /**
